"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.log = exports.isEntryFunc = exports.isRegExp = exports.isEntry = exports.isPlainObject = exports.isString = exports.isType = void 0;
const chalk = require("chalk");
const isType = (type) => (val) => {
    return Object.prototype.toString.call(val) === `[object ${type}]`;
};
exports.isType = isType;
const isString = (val) => {
    return typeof val === 'string';
};
exports.isString = isString;
const isPlainObject = (val) => {
    return val !== null && typeof val === 'object';
};
exports.isPlainObject = isPlainObject;
// only for webpack@4.x
const isEntry = (val) => {
    if (exports.isPlainObject(val)) {
        return Object.values(val).every((value) => {
            return (exports.isString(value) ||
                (Array.isArray(value) && value.every((val) => exports.isString(val))));
        });
    }
    return false;
};
exports.isEntry = isEntry;
const isRegExp = (val) => {
    return exports.isPlainObject(val) && exports.isType('RegExp')(val);
};
exports.isRegExp = isRegExp;
const isEntryFunc = (val) => {
    return typeof val === 'function';
};
exports.isEntryFunc = isEntryFunc;
exports.log = {
    warn: (msg) => {
        console.warn(chalk.red(msg));
    },
};
